float4x4 matView;
float4x4 matViewProjection;

float  alpha1 = 1.f;
float2 ParticleSize = {5.f, 5.f};

texture tex0; //diffuse
sampler2D diffuse = 
sampler_state
{
	texture = (tex0);
	MipFilter = Linear; MagFilter = Linear; MinFilter = Linear;
	AddressU = Clamp; AddressV = Clamp;
};

void vs_partikkel(in float3 ipos : POSITION,
				  in float2 itex : TEXCOORD0,
				  out float4 opos : POSITION,
				  out float2 otex : TEXCOORD0,
				  out float2 otex2 : TEXCOORD1,
				  out float  inter : TEXCOORD2)
{
	float factor = ipos.y;//length(ipos.xyz);
	float dude = ((factor/40.f)*8.f);
	inter = frac(dude);
	int part = floor(dude);
	float xcoord = 1.f/8.f; 
	
	ipos.y = 60.f*sin( (ipos.y/40)*1.2f);
	ipos += float3(matView._11, matView._21, matView._31)*itex.x*ParticleSize.x;
	ipos += float3(matView._12, matView._22, matView._32)*itex.y*ParticleSize.y;
	opos = mul(float4(ipos, 1.f), matViewProjection);
	otex = itex + .5f;
	otex.y = 1.f-otex.y;
	otex2 = otex;
	
	float x = otex.x;
	otex.x = otex.x  * xcoord + (xcoord*part);
	otex2.x = x  * xcoord + (xcoord*(part+1));
}


float4 ps_partikkel(in float2 tex : TEXCOORD0,
					in float2 tex2: TEXCOORD1,
					in float inter : TEXCOORD2) : COLOR0
{
	float4 a = tex2D(diffuse, tex);
	float4 b = tex2D(diffuse, tex2);
	float4 p = lerp(a, b, inter);
	return p*alpha1;
}




technique Partikkel
{
	pass diffuse
	{
		VertexShader = compile vs_2_0 vs_partikkel();
		PixelShader  = compile ps_2_0 ps_partikkel();
	}
}